## obs-studio 29.1.3+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

set(obs-websocket_VERSION 5.2.3)
set(OBS_WEBSOCKET_RPC_VERSION 1)

option(ENABLE_WEBSOCKET "Enable building OBS with websocket plugin" ON)
if(NOT ENABLE_WEBSOCKET)
  target_disable(obs-websocket)
  return()
endif()

# Submodule deps check
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/deps/qr/cpp/QrCode.hpp")
  message(FATAL_ERROR "obs-websocket submodule deps not available.")
endif()

# Find Qt
find_qt(COMPONENTS Core Widgets Svg Network)

# Find nlohmann JSON
find_package(nlohmann_json 3 REQUIRED)

# Find WebSocket++
find_package(Websocketpp 0.8 REQUIRED)

# Find Asio
find_package(Asio 1.12.1 REQUIRED)

add_library(obs-websocket MODULE)
add_library(OBS::websocket ALIAS obs-websocket)

target_sources(obs-websocket PRIVATE)

target_sources(
  obs-websocket
  PRIVATE src/obs-websocket.cpp
          src/obs-websocket.h
          src/Config.cpp
          src/Config.h
          lib/obs-websocket-api.h
          src/forms/ConnectInfo.cpp
          src/forms/ConnectInfo.h
          src/forms/resources.qrc
          src/forms/SettingsDialog.cpp
          src/forms/SettingsDialog.h
          src/WebSocketApi.cpp
          src/WebSocketApi.h)

target_sources(
  obs-websocket
  PRIVATE src/websocketserver/WebSocketServer.cpp
          src/websocketserver/WebSocketServer_Protocol.cpp
          src/websocketserver/WebSocketServer.h
          src/websocketserver/rpc/WebSocketSession.cpp
          src/websocketserver/rpc/WebSocketSession.h
          src/websocketserver/types/WebSocketCloseCode.h
          src/websocketserver/types/WebSocketOpCode.h)

target_sources(
  obs-websocket
  PRIVATE src/eventhandler/EventHandler.cpp
          src/eventhandler/EventHandler.h
          src/eventhandler/EventHandler_Config.cpp
          src/eventhandler/EventHandler_General.cpp
          src/eventhandler/EventHandler_Filters.cpp
          src/eventhandler/EventHandler_Inputs.cpp
          src/eventhandler/EventHandler_MediaInputs.cpp
          src/eventhandler/EventHandler_Outputs.cpp
          src/eventhandler/EventHandler_Scenes.cpp
          src/eventhandler/EventHandler_SceneItems.cpp
          src/eventhandler/EventHandler_Transitions.cpp
          src/eventhandler/EventHandler_Ui.cpp
          src/eventhandler/types/EventSubscription.h)

target_sources(
  obs-websocket
  PRIVATE src/requesthandler/RequestBatchHandler.cpp
          src/requesthandler/RequestBatchHandler.h
          src/requesthandler/RequestHandler.cpp
          src/requesthandler/RequestHandler.h
          src/requesthandler/RequestHandler_Config.cpp
          src/requesthandler/RequestHandler_Filters.cpp
          src/requesthandler/RequestHandler_General.cpp
          src/requesthandler/RequestHandler_Inputs.cpp
          src/requesthandler/RequestHandler_MediaInputs.cpp
          src/requesthandler/RequestHandler_Outputs.cpp
          src/requesthandler/RequestHandler_Sources.cpp
          src/requesthandler/RequestHandler_Record.cpp
          src/requesthandler/RequestHandler_Scenes.cpp
          src/requesthandler/RequestHandler_SceneItems.cpp
          src/requesthandler/RequestHandler_Stream.cpp
          src/requesthandler/RequestHandler_Transitions.cpp
          src/requesthandler/RequestHandler_Ui.cpp
          src/requesthandler/rpc/Request.cpp
          src/requesthandler/rpc/Request.h
          src/requesthandler/rpc/RequestBatchRequest.cpp
          src/requesthandler/rpc/RequestBatchRequest.h
          src/requesthandler/rpc/RequestResult.cpp
          src/requesthandler/rpc/RequestResult.h
          src/requesthandler/types/RequestStatus.h
          src/requesthandler/types/RequestBatchExecutionType.h)

target_sources(
  obs-websocket
  PRIVATE src/utils/Compat.cpp
          src/utils/Compat.h
          src/utils/Crypto.cpp
          src/utils/Crypto.h
          src/utils/Json.cpp
          src/utils/Json.h
          src/utils/Obs.cpp
          src/utils/Obs.h
          src/utils/Obs_ActionHelper.cpp
          src/utils/Obs_ArrayHelper.cpp
          src/utils/Obs_NumberHelper.cpp
          src/utils/Obs_ObjectHelper.cpp
          src/utils/Obs_StringHelper.cpp
          src/utils/Obs_SearchHelper.cpp
          src/utils/Obs_VolumeMeter.cpp
          src/utils/Obs_VolumeMeter.h
          src/utils/Obs_VolumeMeter_Helpers.h
          src/utils/Platform.cpp
          src/utils/Platform.h
          src/utils/Utils.h)

target_sources(obs-websocket PRIVATE deps/qr/cpp/QrCode.cpp deps/qr/cpp/QrCode.hpp)

configure_file(src/plugin-macros.h.in plugin-macros.generated.h)
target_sources(obs-websocket PRIVATE plugin-macros.generated.h)

target_compile_definitions(
  obs-websocket PRIVATE ASIO_STANDALONE $<$<BOOL:PLUGIN_TESTS>:PLUGIN_TESTS>
                        $<$<PLATFORM_ID:Windows>:_WEBSOCKETPP_CPP11_STL_> $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=0x0603>)

target_compile_options(
  obs-websocket
  PRIVATE
    $<$<PLATFORM_ID:Windows>:/wd4267>
    $<$<PLATFORM_ID:Windows>:/wd4996>
    $<$<PLATFORM_ID:Darwin,Linux,FreeBSD>:-Wall>
    $<$<COMPILE_LANG_AND_ID:CXX,GNU,AppleClang,Clang>:-Wno-error=float-conversion;-Wno-error=shadow>
    $<$<COMPILE_LANG_AND_ID:CXX,GNU>:-Wno-error=format-overflow;-Wno-error=int-conversion;-Wno-error=comment>
    $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-error=null-pointer-subtraction;-Wno-error=deprecated-declarations;-Wno-error=implicit-int-conversion;-Wno-error=shorten-64-to-32;-Wno-comma;-Wno-quoted-include-in-framework-header>
)

target_link_libraries(
  obs-websocket
  PRIVATE OBS::libobs
          OBS::frontend-api
          Qt::Core
          Qt::Widgets
          Qt::Svg
          Qt::Network
          nlohmann_json::nlohmann_json
          Websocketpp::Websocketpp
          Asio::Asio)

set_target_properties_obs(
  obs-websocket
  PROPERTIES FOLDER plugins
             PREFIX ""
             AUTOMOC ON
             AUTOUIC ON
             AUTORCC ON)

if(OS_WINDOWS)
  set_property(
    TARGET obs-websocket
    APPEND
    PROPERTY AUTORCC_OPTIONS --format-version 1)
endif()

=== libobs-opengl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

add_library(libobs-opengl SHARED)
add_library(OBS::libobs-opengl ALIAS libobs-opengl)

if(NOT TARGET OBS::glad)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/glad" "${CMAKE_BINARY_DIR}/deps/glad")
endif()

target_sources(
  libobs-opengl
  PRIVATE gl-helpers.c
          gl-helpers.h
          gl-indexbuffer.c
          gl-shader.c
          gl-shaderparser.c
          gl-shaderparser.h
          gl-stagesurf.c
          gl-subsystem.c
          gl-subsystem.h
          gl-texture2d.c
          gl-texture3d.c
          gl-texturecube.c
          gl-vertexbuffer.c
          gl-zstencil.c)

target_link_libraries(libobs-opengl PRIVATE OBS::libobs OBS::glad)

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in libobs-opengl.rc)

  target_sources(libobs-opengl PRIVATE gl-windows.c libobs-opengl.rc)
elseif(OS_MACOS)
  find_library(COCOA Cocoa)
  find_library(IOSURF IOSurface)

  target_sources(libobs-opengl PRIVATE gl-cocoa.m)
  target_compile_definitions(libobs-opengl PRIVATE GL_SILENCE_DEPRECATION)

  target_link_libraries(libobs-opengl PRIVATE ${COCOA} ${IOSURF})
elseif(OS_LINUX OR OS_FREEBSD)
  find_package(X11 REQUIRED)
  find_package(
    xcb
    COMPONENTS xcb
    REQUIRED)
  find_package(x11-xcb REQUIRED)

  target_sources(libobs-opengl PRIVATE gl-egl-common.c gl-nix.c gl-x11-egl.c)
  target_link_libraries(libobs-opengl PRIVATE xcb::xcb X11::x11-xcb)

  if(ENABLE_WAYLAND)
    find_package(
      OpenGL
      COMPONENTS EGL
      REQUIRED)

    find_package(Wayland REQUIRED)

    target_sources(libobs-opengl PRIVATE gl-wayland-egl.c)
    target_link_libraries(libobs-opengl PRIVATE OpenGL::EGL Wayland::EGL)
  endif()

endif()

target_enable_feature(libobs "OpenGL renderer")

set_target_properties_obs(
  libobs-opengl
  PROPERTIES FOLDER core
             VERSION 0
             PREFIX ""
             SOVERSION "${OBS_VERSION_MAJOR}")

=== libobs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

add_library(libobs SHARED)
add_library(OBS::libobs ALIAS libobs)

find_package(Threads REQUIRED)
find_package(FFmpeg REQUIRED avformat avutil swscale swresample OPTIONAL_COMPONENTS avcodec)
find_package(ZLIB REQUIRED)

if(ENABLE_UI)
  find_qt(COMPONENTS Core)
endif()

find_package(jansson REQUIRED)
add_subdirectory("${CMAKE_SOURCE_DIR}/deps/libcaption" "${CMAKE_BINARY_DIR}/deps/libcaption")
add_subdirectory("${CMAKE_SOURCE_DIR}/deps/uthash" "${CMAKE_BINARY_DIR}/deps/uthash")

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          $<$<BOOL:${ENABLE_HEVC}>:obs-hevc.c>
          $<$<BOOL:${ENABLE_HEVC}>:obs-hevc.h>
          obs-audio-controls.c
          obs-audio-controls.h
          obs-audio.c
          obs-avc.c
          obs-avc.h
          obs-data.c
          obs-data.h
          obs-defs.h
          obs-display.c
          obs-encoder.c
          obs-encoder.h
          obs-ffmpeg-compat.h
          obs-hotkey-name-map.c
          obs-hotkey.c
          obs-hotkey.h
          obs-hotkeys.h
          obs-interaction.h
          obs-internal.h
          obs-missing-files.c
          obs-missing-files.h
          obs-module.c
          obs-module.h
          obs-nal.c
          obs-nal.h
          obs-output-delay.c
          obs-output.c
          obs-output.h
          obs-properties.c
          obs-properties.h
          obs-scene.c
          obs-scene.h
          obs-service.c
          obs-service.h
          obs-source-deinterlace.c
          obs-source-transition.c
          obs-source.c
          obs-source.h
          obs-ui.h
          obs-video-gpu-encode.c
          obs-video.c
          obs-view.c
          obs.c
          obs.h
          obs.hpp)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          util/array-serializer.c
          util/array-serializer.h
          util/base.c
          util/base.h
          util/bitstream.c
          util/bitstream.h
          util/bmem.c
          util/bmem.h
          util/c99defs.h
          util/cf-lexer.c
          util/cf-lexer.h
          util/cf-parser.c
          util/cf-parser.h
          util/circlebuf.h
          util/config-file.c
          util/config-file.h
          util/crc32.c
          util/crc32.h
          util/curl/curl-helper.h
          util/darray.h
          util/dstr.c
          util/dstr.h
          util/file-serializer.c
          util/file-serializer.h
          util/lexer.c
          util/lexer.h
          util/pipe.h
          util/platform.c
          util/platform.h
          util/profiler.c
          util/profiler.h
          util/profiler.hpp
          util/serializer.h
          util/sse-intrin.h
          util/task.c
          util/task.h
          util/text-lookup.c
          util/text-lookup.h
          util/threading.h
          util/utf8.c
          util/utf8.h
          util/uthash.h
          util/util.hpp
          util/util_uint128.h
          util/util_uint64.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          util/simde/check.h
          util/simde/debug-trap.h
          util/simde/hedley.h
          util/simde/simde-align.h
          util/simde/simde-arch.h
          util/simde/simde-common.h
          util/simde/simde-constify.h
          util/simde/simde-detect-clang.h
          util/simde/simde-diagnostic.h
          util/simde/simde-features.h
          util/simde/simde-math.h
          util/simde/x86/mmx.h
          util/simde/x86/sse.h
          util/simde/x86/sse2.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          callback/calldata.c
          callback/calldata.h
          callback/decl.c
          callback/decl.h
          callback/proc.c
          callback/proc.h
          callback/signal.c
          callback/signal.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          media-io/audio-io.c
          media-io/audio-io.h
          media-io/audio-math.h
          media-io/audio-resampler-ffmpeg.c
          media-io/audio-resampler.h
          media-io/format-conversion.c
          media-io/format-conversion.h
          media-io/frame-rate.h
          media-io/media-io-defs.h
          media-io/media-remux.c
          media-io/media-remux.h
          media-io/video-fourcc.c
          media-io/video-frame.c
          media-io/video-frame.h
          media-io/video-io.c
          media-io/video-io.h
          media-io/video-matrices.c
          media-io/video-scaler-ffmpeg.c
          media-io/video-scaler.h)

target_sources(
  libobs
  PRIVATE # cmake-format: sortable
          graphics/axisang.c
          graphics/axisang.h
          graphics/bounds.c
          graphics/bounds.h
          graphics/device-exports.h
          graphics/effect-parser.c
          graphics/effect-parser.h
          graphics/effect.c
          graphics/effect.h
          graphics/graphics-ffmpeg.c
          graphics/graphics-imports.c
          graphics/graphics-internal.h
          graphics/graphics.c
          graphics/graphics.h
          graphics/half.h
          graphics/image-file.c
          graphics/image-file.h
          graphics/input.h
          graphics/libnsgif/libnsgif.c
          graphics/libnsgif/libnsgif.h
          graphics/math-defs.h
          graphics/math-extra.c
          graphics/math-extra.h
          graphics/matrix3.c
          graphics/matrix3.h
          graphics/matrix4.c
          graphics/matrix4.h
          graphics/plane.c
          graphics/plane.h
          graphics/quat.c
          graphics/quat.h
          graphics/shader-parser.c
          graphics/shader-parser.h
          graphics/srgb.h
          graphics/texture-render.c
          graphics/vec2.c
          graphics/vec2.h
          graphics/vec3.c
          graphics/vec3.h
          graphics/vec4.c
          graphics/vec4.h)

target_compile_features(libobs PUBLIC $<INSTALL_INTERFACE:cxx_std_17>)
target_compile_options(libobs PUBLIC ${ARCH_SIMD_FLAGS})
target_compile_definitions(
  libobs
  PRIVATE IS_LIBOBS
  PUBLIC ${ARCH_SIMD_DEFINES} $<BUILD_INTERFACE:$<$<BOOL:${ENABLE_HEVC}>:ENABLE_HEVC>>
         $<BUILD_INTERFACE:$<$<BOOL:${ENABLE_FFMPEG_MUX_DEBUG}>:SHOW_SUBPROCESSES>>)

target_link_libraries(
  libobs
  PRIVATE OBS::caption
          OBS::uthash
          FFmpeg::avcodec
          FFmpeg::avformat
          FFmpeg::avutil
          FFmpeg::swscale
          FFmpeg::swresample
          jansson::jansson
          ZLIB::ZLIB
  PUBLIC Threads::Threads)

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX)
  include(cmake/os-linux.cmake)
elseif(OS_FREEBSD)
  include(cmake/os-freebsd.cmake)
endif()

configure_file(obsconfig.h.in "${CMAKE_BINARY_DIR}/config/obsconfig.h" @ONLY)
target_include_directories(libobs PUBLIC "$<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/config>"
                                         "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")
target_compile_definitions(libobs PUBLIC HAVE_OBSCONFIG_H)

set(public_headers
    # cmake-format: sortable
    callback/calldata.h
    callback/proc.h
    callback/signal.h
    graphics/graphics.h
    graphics/input.h
    graphics/math-defs.h
    graphics/srgb.h
    graphics/vec2.h
    graphics/vec3.h
    graphics/vec4.h
    media-io/audio-io.h
    media-io/frame-rate.h
    media-io/media-io-defs.h
    media-io/video-io.h
    obs-audio-controls.h
    obs-config.h
    obs-data.h
    obs-defs.h
    obs-encoder.h
    obs-hotkey.h
    obs-hotkeys.h
    obs-interaction.h
    obs-internal.h
    obs-missing-files.h
    obs-module.h
    obs-output.h
    obs-properties.h
    obs-service.h
    obs-source.h
    obs-ui.h
    obs.h
    obs.hpp
    util/base.h
    util/bmem.h
    util/c99defs.h
    util/darray.h
    util/profiler.h
    util/sse-intrin.h
    util/text-lookup.h
    util/util_uint64.h)

if(ENABLE_HEVC)
  list(APPEND public_headers obs-hevc.h)
endif()

if(ARCH_SIMD_FLAGS)
  set(public_headers
      # cmake-format: sortable
      ${public_headers}
      util/simde/check.h
      util/simde/debug-trap.h
      util/simde/hedley.h
      util/simde/simde-align.h
      util/simde/simde-arch.h
      util/simde/simde-common.h
      util/simde/simde-constify.h
      util/simde/simde-detect-clang.h
      util/simde/simde-diagnostic.h
      util/simde/simde-features.h
      util/simde/simde-math.h
      util/simde/x86/mmx.h
      util/simde/x86/sse.h
      util/simde/x86/sse2.h)
endif()

set_property(
  TARGET libobs
  APPEND
  PROPERTY OBS_PUBLIC_HEADERS ${public_headers})

set_target_properties_obs(
  libobs
  PROPERTIES FOLDER core
             VERSION 0
             SOVERSION "${OBS_VERSION_MAJOR}")

target_export(libobs)

=== plugins/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

option(ENABLE_PLUGINS "Enable building OBS plugins" ON)

if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)

  if(NOT ENABLE_PLUGINS)
    set_property(GLOBAL APPEND PROPERTY OBS_FEATURES_DISABLED "Plugin Support")
    return()
  endif()

  set_property(GLOBAL APPEND PROPERTY OBS_FEATURES_ENABLED "Plugin Support")

  macro(check_obs_browser)
    if(NOT (OS_WINDOWS AND NOT CMAKE_GENERATOR_PLATFORM MATCHES "(Win32|x64)"))
      if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/obs-browser/cmake/macos/Info.plist.in")
        add_subdirectory(obs-browser)
      elseif(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/obs-browser/CMakeLists.txt")
        message(FATAL_ERROR "Required submodule 'obs-browser' not available.")
      endif()
    endif()
  endmacro()

  macro(check_obs_websocket)
    if(OS_WINDOWS
       OR OS_MACOS
       OR OS_LINUX)
      if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/obs-websocket/cmake/macos/Info.plist.in")
        add_subdirectory(obs-websocket)
      elseif(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/obs-websocket/CMakeLists.txt")
        message(FATAL_ERROR "Required submodule 'obs-websocket' not available.")
      endif()
    endif()
  endmacro()

  # Add plugins in alphabetical order to retain order in IDE projects
  add_subdirectory(aja)
  if(OS_WINDOWS OR OS_MACOS)
    add_subdirectory(coreaudio-encoder)
  endif()
  if(OS_WINDOWS
     OR OS_MACOS
     OR OS_LINUX)
    add_subdirectory(decklink)
  endif()
  if(OS_WINDOWS)
    add_subdirectory(enc-amf)
  endif()
  add_subdirectory(image-source)
  if(OS_LINUX)
    add_subdirectory(linux-alsa)
    add_subdirectory(linux-capture)
    add_subdirectory(linux-jack)
    add_subdirectory(linux-pipewire)
    add_subdirectory(linux-pulseaudio)
    add_subdirectory(linux-v4l2)
  endif()
  if(OS_MACOS)
    add_subdirectory(mac-avcapture)
    add_subdirectory(mac-capture)
    add_subdirectory(mac-syphon)
    add_subdirectory(mac-videotoolbox)
    add_subdirectory(mac-virtualcam)
  endif()
  check_obs_browser()
  add_subdirectory(obs-ffmpeg)
  add_subdirectory(obs-filters)
  add_subdirectory(obs-outputs)
  if(OS_WINDOWS)
    add_subdirectory(obs-qsv11)
    add_subdirectory(obs-text)
  endif()
  add_subdirectory(obs-transitions)
  if(OS_WINDOWS
     OR OS_MACOS
     OR OS_LINUX)
    add_subdirectory(obs-vst)
  endif()
  check_obs_websocket()
  add_subdirectory(obs-x264)
  add_subdirectory(rtmp-services)
  if(OS_LINUX)
    add_subdirectory(sndio)
  endif()
  add_subdirectory(text-freetype2)
  if(OS_WINDOWS
     OR OS_MACOS
     OR OS_LINUX)
    add_subdirectory(vlc-video)
  endif()
  if(OS_WINDOWS)
    add_subdirectory(win-capture)
    add_subdirectory(win-dshow)
    add_subdirectory(win-wasapi)
  endif()
  return()
endif()

if(NOT ENABLE_PLUGINS)
  obs_status(STATUS "Building with plugins disabled.")
  return()
endif()

function(check_obs_browser)
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/obs-browser/CMakeLists.txt)
    add_subdirectory(obs-browser)
  else()
    obs_status(FATAL_ERROR "obs-browser submodule not available.")
  endif()
endfunction()

# APPLE/WIN32/UNIX are soft-deprecated: https://discourse.cmake.org/t/platform-id-vs-win32-vs-cmake-system-name/1226/2
if(OS_WINDOWS)
  add_subdirectory(coreaudio-encoder)
  add_subdirectory(win-wasapi)
  add_subdirectory(win-dshow)
  add_subdirectory(win-capture)
  add_subdirectory(decklink)
  add_subdirectory(obs-qsv11)
  add_subdirectory(obs-text)
  add_subdirectory(vlc-video)
  add_subdirectory(obs-vst)

  if(EXISTS "${CMAKE_CURRENT_LIST_DIR}/enc-amf/CMakeLists.txt")
    add_subdirectory(enc-amf)
  else()
    obs_status(WARNING "enc-amf plugin not found.")
  endif()

  check_obs_browser()
elseif(OS_MACOS)
  add_subdirectory(coreaudio-encoder)
  add_subdirectory(mac-avcapture)
  add_subdirectory(mac-capture)
  add_subdirectory(mac-videotoolbox)
  add_subdirectory(mac-syphon)
  add_subdirectory(mac-virtualcam)
  add_subdirectory(decklink)
  add_subdirectory(vlc-video)
  add_subdirectory(linux-jack)
  add_subdirectory(obs-vst)

  check_obs_browser()
elseif(OS_LINUX)
  add_subdirectory(linux-capture)
  add_subdirectory(linux-pulseaudio)
  add_subdirectory(linux-v4l2)
  add_subdirectory(linux-jack)
  add_subdirectory(linux-alsa)
  add_subdirectory(linux-pipewire)
  add_subdirectory(decklink)
  add_subdirectory(vlc-video)
  add_subdirectory(sndio)
  add_subdirectory(obs-vst)

  check_obs_browser()
elseif(OS_FREEBSD)
  add_subdirectory(linux-capture)
  add_subdirectory(linux-pipewire)
  add_subdirectory(linux-pulseaudio)
  add_subdirectory(linux-v4l2)
  add_subdirectory(linux-jack)
  add_subdirectory(linux-alsa)
  add_subdirectory(vlc-video)
  add_subdirectory(oss-audio)
  add_subdirectory(sndio)

  obs_status(STATUS "obs-browser plugin not available.")
  obs_status(STATUS "obs-vst plugin not available.")
elseif(OS_OPENBSD)
  add_subdirectory(linux-capture)
  add_subdirectory(sndio)

  obs_status(STATUS "obs-browser plugin not available.")
  obs_status(STATUS "obs-vst plugin not available.")
endif()

if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/obs-websocket/CMakeLists.txt)
  add_subdirectory(obs-websocket)
else()
  obs_status(FATAL_ERROR "obs-websocket submodule not available.")
endif()

add_subdirectory(image-source)
add_subdirectory(obs-x264)
add_subdirectory(obs-libfdk)
add_subdirectory(obs-ffmpeg)
add_subdirectory(obs-outputs)
add_subdirectory(obs-filters)
add_subdirectory(obs-transitions)
add_subdirectory(rtmp-services)
add_subdirectory(text-freetype2)
add_subdirectory(aja)

=== UI/obs-frontend-api/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

add_library(obs-frontend-api SHARED)
add_library(OBS::frontend-api ALIAS obs-frontend-api)

target_sources(obs-frontend-api PRIVATE obs-frontend-api.h obs-frontend-api.cpp obs-frontend-internal.hpp)

target_link_libraries(obs-frontend-api PRIVATE OBS::libobs)

target_include_directories(obs-frontend-api PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in obs-frontend-api.rc)
  target_sources(obs-frontend-api PRIVATE obs-frontend-api.rc)
elseif(OS_MACOS)
  set_target_properties(obs-frontend-api PROPERTIES SOVERSION 1)
endif()

set_target_properties_obs(obs-frontend-api PROPERTIES FOLDER frontend PREFIX "" PUBLIC_HEADER obs-frontend-api.h)

target_export(obs-frontend-api)

=== deps/glad/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

find_package(OpenGL REQUIRED)

add_library(obsglad STATIC EXCLUDE_FROM_ALL )
add_library(OBS::glad ALIAS obsglad)

if(OBS_CMAKE_VERSION VERSION_LESS 3.0.0)
  add_library(OBS::obsglad ALIAS obsglad)
endif()

target_sources(obsglad PRIVATE src/glad.c include/glad/glad.h)

target_include_directories(obsglad PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

target_link_libraries(obsglad PUBLIC OpenGL::GL)

if(OS_WINDOWS)
  target_sources(obsglad PRIVATE src/glad_wgl.c include/glad/glad_wgl.h)
elseif(OS_LINUX OR OS_FREEBSD)
  if(TARGET OpenGL::EGL)
    target_sources(obsglad PRIVATE src/glad_egl.c include/EGL/eglplatform.h include/glad/glad_egl.h)

    target_link_libraries(obsglad PRIVATE OpenGL::EGL)
  endif()
endif()

set_target_properties(obsglad PROPERTIES FOLDER deps POSITION_INDEPENDENT_CODE TRUE)

=== deps/ipc-util/CMakeLists.txt ===
project(ipc-util)

add_library(ipc-util STATIC)
add_library(OBS::ipc-util ALIAS ipc-util)

target_sources(ipc-util PRIVATE ipc-util/pipe.h)

set_target_properties(ipc-util PROPERTIES FOLDER "deps" POSITION_INDEPENDENT_CODE ON)

target_include_directories(ipc-util PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

if(OS_WINDOWS)
  if(MSVC)
    target_compile_options(ipc-util PRIVATE "$<IF:$<CONFIG:Debug>,/MTd,/MT>" /Zl)
  endif()

  target_sources(ipc-util PRIVATE ipc-util/pipe-windows.c ipc-util/pipe-windows.h)
else()
  target_sources(ipc-util PRIVATE ipc-util/pipe-posix.c ipc-util/pipe-posic.h)
endif()

=== deps/libcaption/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

add_library(caption STATIC EXCLUDE_FROM_ALL )
add_library(OBS::caption ALIAS caption)

target_sources(
  caption
  PRIVATE src/caption.c
          src/cea708.c
          src/eia608.c
          src/eia608_charmap.c
          src/eia608_from_utf8.c
          src/mpeg.c
          src/srt.c
          src/scc.c
          src/utf8.c
          src/xds.c
          caption/eia608.h
          caption/eia608_charmap.h
          caption/cea708.h
          caption/mpeg.h
          caption/scc.h
          caption/utf8.h
  PUBLIC caption/caption.h)

target_compile_definitions(caption PRIVATE __STDC_CONSTANT_MACROS $<$<CXX_COMPILER_ID:MSVC>:_CRT_SECURE_NO_WARNINGS>)

target_compile_options(caption PRIVATE $<$<CXX_COMPILER_ID:Clang,AppleClang,GNU>:-Wno-unused-but-set-parameter>)

target_include_directories(
  caption
  PRIVATE caption
  PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}")

set_target_properties(caption PROPERTIES FOLDER deps POSITION_INDEPENDENT_CODE ON)

=== deps/obs-scripting/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

if(NOT ENABLE_SCRIPTING)
  target_disable_feature(obs-scripting "Scripting support")
  return()
endif()

add_library(obs-cstrcache INTERFACE)
add_library(OBS::cstrcache ALIAS obs-cstrcache)

target_sources(obs-cstrcache INTERFACE cstrcache.cpp cstrcache.h)
target_include_directories(obs-cstrcache INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

find_package(SWIG 4 REQUIRED)

add_library(obs-scripting SHARED)
add_library(OBS::scripting ALIAS obs-scripting)

include(cmake/lua.cmake)
include(cmake/python.cmake)

if(NOT ENABLE_SCRIPTING_LUA AND NOT ENABLE_SCRIPTING_PYTHON)
  target_disable_feature(obs-scripting "Scripting support")
  return()
else()
  target_enable_feature(obs-scripting "Scripting support")
endif()

target_sources(
  obs-scripting
  PUBLIC obs-scripting.h
  PRIVATE obs-scripting.c obs-scripting-logging.c obs-scripting-callback.h
          $<$<BOOL:${ENABLE_UI}>:obs-scripting-python-frontend.c> $<$<BOOL:${ENABLE_UI}>:obs-scripting-lua-frontend.c>)

target_compile_definitions(obs-scripting PRIVATE SCRIPT_DIR="${OBS_SCRIPT_PLUGIN_PATH}"
                                                 $<$<BOOL:${ENABLE_UI}>:ENABLE_UI>)
target_compile_features(obs-scripting PRIVATE cxx_auto_type)
target_include_directories(obs-scripting PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(obs-scripting PRIVATE OBS::libobs OBS::cstrcache $<$<BOOL:${ENABLE_UI}>:OBS::frontend-api>
                                            $<$<PLATFORM_ID:Windows>:OBS::w32-pthreads> $<$<PLATFORM_ID:Darwin>:objc>)

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in obs-scripting.rc)
  target_sources(obs-scripting PRIVATE obs-scripting.rc)
endif()

set_target_properties_obs(obs-scripting PROPERTIES FOLDER scripting PREFIX "")

=== deps/uthash/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

add_library(uthash INTERFACE)
add_library(OBS::uthash ALIAS uthash)

target_sources(uthash INTERFACE uthash/uthash.h)

set_target_properties(uthash PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}")

=== plugins/aja/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

option(ENABLE_AJA "Build OBS with aja support" ON)

if(NOT ENABLE_AJA)
  set_property(GLOBAL APPEND PROPERTY OBS_MODULES_DISABLED aja)
  return()
endif()

find_package(LibAJANTV2 REQUIRED)

add_library(aja MODULE)
add_library(OBS::aja ALIAS aja)

target_sources(
  aja
  PRIVATE main.cpp
          aja-card-manager.cpp
          aja-common.cpp
          aja-common.hpp
          aja-output.cpp
          aja-enums.hpp
          aja-output.hpp
          aja-presets.cpp
          aja-presets.hpp
          aja-props.cpp
          aja-props.hpp
          aja-routing.cpp
          aja-routing.hpp
          aja-source.cpp
          aja-source.hpp
          aja-vpid-data.cpp
          aja-vpid-data.hpp
          aja-widget-io.cpp
          aja-widget-io.hpp
          aja-card-manager.hpp
          aja-ui-props.hpp
          audio-repack.c
          audio-repack.h
          audio-repack.hpp)

target_link_libraries(aja PRIVATE OBS::libobs AJA::LibAJANTV2)

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in win-aja.rc)
  target_sources(aja PRIVATE win-aja.rc)

  target_compile_options(aja PRIVATE /wd4996)

  target_link_libraries(aja PRIVATE ws2_32.lib setupapi.lib Winmm.lib netapi32.lib Shlwapi.lib)
  target_link_options(aja PRIVATE /IGNORE:4099)

elseif(OS_MACOS)
  find_library(IOKIT IOKit)
  find_library(COREFOUNDATION CoreFoundation)
  find_library(APPKIT AppKit)

  target_link_libraries(aja PRIVATE ${IOKIT} ${COREFOUNDATION} ${APPKIT})
  target_compile_options(aja PRIVATE -Wno-error=deprecated-declarations)
elseif(OS_LINUX OR OS_FREEBSD)
  target_compile_options(aja PRIVATE -Wno-error=deprecated-declarations)
endif()

set_target_properties_obs(aja PROPERTIES FOLDER plugins PREFIX "")

=== plugins/coreaudio-encoder/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.24...3.25)

legacy_check()

if(OS_WINDOWS)
  option(ENABLE_COREAUDIO_ENCODER "Enable building with CoreAudio encoder (Windows)" ON)
  if(NOT ENABLE_COREAUDIO_ENCODER)
    target_disable(coreaudio-encoder)
    return()
  endif()
endif()

add_library(coreaudio-encoder MODULE)
add_library(OBS::coreaudio-encoder ALIAS coreaudio-encoder)

target_sources(coreaudio-encoder PRIVATE encoder.cpp)
target_link_libraries(coreaudio-encoder PRIVATE OBS::libobs)

if(OS_WINDOWS)
  target_compile_definitions(coreaudio-encoder PRIVATE UNICODE _UNICODE)

  configure_file(cmake/windows/obs-module.rc.in coreaudio-encoder.rc)

  target_sources(coreaudio-encoder PRIVATE coreaudio-encoder.rc windows-imports.h)
elseif(OS_MACOS)
  find_library(COREFOUNDATION CoreFoundation)
  find_library(COREAUDIO CoreAudio)
  find_library(AUDIOTOOLBOX AudioToolbox)
  mark_as_advanced(AUDIOTOOLBOX COREAUDIO COREFOUNDATION)

  target_link_libraries(coreaudio-encoder PRIVATE ${COREFOUNDATION} ${COREAUDIO} ${AUDIOTOOLBOX})

endif()

set_target_properties_obs(coreaudio-encoder PROPERTIES FOLDER plugins PREFIX "")

=== debian/changelog ===
obs-studio (29.1.3+dfsg-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 30 Oct 2023 13:41:42 -0700

obs-studio (29.1.3+dfsg-2) unstable; urgency=medium

  * Generalize the prevention of SIMD-builds
    + Disable SIMD on i386 (and ignore up psABI warnings)
      (Fixes FTBFS on i386)
  * Add patch to fix out-of-type-limits comparison if (char)==(unsigned char)
    (Fixes FTBFS on armel, armhf, ppc64el, s390x)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 02 Aug 2023 13:39:19 +0200

obs-studio (29.1.3+dfsg-1) unstable; urgency=medium

  * New upstream version 29.1.3+dfsg
    + Refresh patches
  * Update simde patch
  * Fix FTBFS due to overzealous warnings
  * Fix format-error FTBFS on 32bit archs
  * Add patch to prevent underlinking
  * Globally apply "-fvisibility=hidden"
    + Drop symbols removed with visibility=hidden
    + Add new symbols
  * Add lintian-overrides for half-excluded files
  * Update d/copyright
    + Refresh licensecheck exclusion rules
    + Re-generate d/copyright_hints

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 31 Jul 2023 14:10:09 +0200

=== debian/control ===
Source: obs-studio
Section: video
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Carl Fürstenberg <azatoth@gmail.com>,
           Sebastian Ramacher <sramacher@debian.org>,
           IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               dh-sequence-scour,
               gir1.2-rsvg-2.0,
               libasio-dev,
               libasound2-dev,
               libavcodec-dev,
               libavdevice-dev,
               libavfilter-dev,
               libavformat-dev,
               libavutil-dev,
               libcurl4-gnutls-dev | libcurl-dev,
               libdbus-1-dev,
               libdrm-dev,
               libffmpeg-nvenc-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libjack-jackd2-dev,
               libjansson-dev,
               libluajit-5.1-dev [!ppc64el],
               libmbedtls-dev,
               libopengl-dev,
               libpci-dev,
               libpipewire-0.3-dev,
               libpulse-dev,
               libqrcodegen-dev,
               libqt5svg5-dev,
               libqt5x11extras5-dev,
               librist-dev,
               libsimde-dev,
               libspeexdsp-dev,
               libsrt-openssl-dev,
               libswresample-dev,
               libswscale-dev,
               libudev-dev,
               libv4l-dev,
               libva-dev,
               libvlc-dev,
               libwayland-dev,
               libwebsocketpp-dev,
               libx11-dev,
               libx11-xcb-dev,
               libx264-dev,
               libxcb-composite0-dev,
               libxcb-randr0-dev,
               libxcb-shm0-dev,
               libxcb-xfixes0-dev,
               libxcb-xinerama0-dev,
               libxcb-xinput-dev,
               libxcomposite-dev,
               libxinerama-dev,
               nlohmann-json3-dev,
               python3-dev,
               python3-docutils,
               python3-gi-cairo,
               qtbase5-dev,
               qtbase5-private-dev,
               swig
Standards-Version: 4.6.2
Homepage: https://obsproject.com
Vcs-Browser: https://salsa.debian.org/multimedia-team/obs-studio
Vcs-Git: https://salsa.debian.org/multimedia-team/obs-studio.git
Rules-Requires-Root: no

Package: obs-studio
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: obs-plugins (= ${binary:Version})
Suggests: pkexec | policykit-1, v4l2loopback-dkms
Breaks: obs-websocket (<< 4.9.0-2.1~)
Replaces: obs-websocket (<< 4.9.0-2.1~)
Description: recorder and streamer for live video content
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 Other features include:
  * Encoding using H264 (x264) and AAC
  * Unlimited number of scenes and sources
  * File output to MP4 or FLV
  * GPU-based game capture for high performance game streaming
  * Bilinear or lanczos3 resampling
 .
 Note that OBS Studio requires an OpenGL 3.2 compatible video card.

Package: obs-plugins
Architecture: any
Built-Using: ${simde:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: vlc
Multi-Arch: same
Description: recorder and streamer for live video content (plugins)
 OBS Studio is designed for efficiently recording and streaming live
 video content. It supports live RTP streaming to various streaming sites.
 .
 This package contains some extra plugins (ALSA, JACK, PipeWire, DeckLink,
 VLC).

Package: libobs0
Multi-Arch: same
Section: libs
Architecture: any
Built-Using: ${simde:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: recorder and streamer for live video content (shared library)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the shared library libobs.

Package: libobs-dev
Section: libdevel
Architecture: any
Depends: libobs0 (= ${binary:Version}),
         libsimde-dev,
         libx11-dev,
         ${misc:Depends}
Description: recorder and streamer for live video content (development files)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_CPPFLAGS_MAINT_APPEND=-DFFMPEG_MUX_FIXED=\"/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg/obs-ffmpeg-mux\"
export DEB_CFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3 -fvisibility=hidden
export DEB_CXXFLAGS_MAINT_APPEND+=-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3 -fvisibility=hidden

confflags  = -DOBS_MULTIARCH_SUFFIX=/$(DEB_HOST_MULTIARCH)
confflags += -DUNIX_STRUCTURE=TRUE
confflags += -DCMAKE_SKIP_RPATH=TRUE
confflags += -DDISABLE_UPDATE_MODULE=TRUE
confflags += -DBUILD_VST=OFF
confflags += -DENABLE_AJA=OFF
confflags += -DENABLE_SNDIO=OFF
confflags += -DENABLE_JACK=TRUE
confflags += -DOBS_VERSION_OVERRIDE=$(subst +dfsg,.1,$(DEB_VERSION))
confflags += -DAPPDATA_RELEASE_DATE=$(shell date --utc --date=@$${SOURCE_DATE_EPOCH} +'%Y-%m-%d')

ifeq (ppc64el,$(DEB_HOST_ARCH))
confflags += -DENABLE_SCRIPTING_LUA=OFF
endif

ifeq ($(DEB_HOST_ARCH_CPU), i386)
confflags += -DENABLE_SIMD=OFF
DEB_CFLAGS_MAINT_APPEND+=-Wno-error=psabi
DEB_CPPFLAGS_MAINT_APPEND+=-Wno-error=psabi
endif


%:
	dh $@

execute_before_dh_auto_configure:
	cp -r websocket plugins/obs-websocket
	mkdir -p plugins/obs-websocket/deps
	cp -r debian/extra/qr plugins/obs-websocket/deps/
	-find plugins/obs-websocket/ -name ".git*" -exec rm -rf {} +
override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

execute_after_dh_auto_build:
	rst2man debian/obs.rst > debian/obs.1

execute_after_dh_auto_install:
	-find debian/tmp -type f -name "*.pem" -exec chmod a-x {} +
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg
	mv debian/tmp/usr/bin/obs-ffmpeg-mux \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/obs-plugins/obs-ffmpeg/obs-ffmpeg-mux
execute_after_dh_install:
	rm -rf debian/obs-studio/usr/share/obs/obs-studio/license

execute_before_dh_shlibdeps:
	echo "libobs 0 libobs0 (= ${DEB_VERSION})" > debian/shlibs.local

override_dh_python3:
	dh_python3 -p obs-studio usr/share/obs/obs-plugins/frontend-tools/scripts
	dh_python3 -p obs-studio usr/lib/$(DEB_HOST_MULTIARCH)/obs-scripting

override_dh_gencontrol:
	dh_gencontrol -- -Vsimde:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsimde-dev")"

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

################################################################
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
	debian/.*|.*\.ttf|.*\.png|cmake/macos/resources/AppIcon.icns|cmake/macos/resources/background.tiff
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints
